Summary:	Userspace tools for bcachefs
Summary(pl.UTF-8):	Narzędzia przestrzeni użytkownika do bcachefs
Name:		bcachefs-tools
Version:	1.13.0
Release:	1
License:	GPL v2+
Group:		Applications/System
Source0:	https://evilpiepirate.org/bcachefs-tools/%{name}-vendored-%{version}.tar.zst
# Source0-md5:	5ee95803cdd9b2a591b38537d13b027c
Patch0:		rust-target.patch
URL:		https://bcachefs.org/
BuildRequires:	cargo
BuildRequires:	clang
%ifnarch x32
BuildRequires:	clang-devel
%else
BuildRequires:	clang-devel(x86-64)
%endif
BuildRequires:	keyutils-devel
BuildRequires:	libaio-devel
BuildRequires:	libblkid-devel
BuildRequires:	libfuse3-devel >= 3.7
BuildRequires:	libsodium-devel
BuildRequires:	libuuid-devel
BuildRequires:	llvm-devel
BuildRequires:	lz4-devel
BuildRequires:	pkgconfig
BuildRequires:	rust >= 1.77
BuildRequires:	systemd-devel
BuildRequires:	tar >= 1:1.22
BuildRequires:	udev-devel
BuildRequires:	userspace-rcu-devel
BuildRequires:	zlib-devel
BuildRequires:	zstd
BuildRequires:	zstd-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%define		filterout_c	-fvar-tracking-assignments

%description
Bcachefs is an advanced new filesystem for Linux, with an emphasis on
reliability and robustness and the complete set of features one would
expect from a modern filesystem.

This package contains userspace tools to manage bcachefs.

%description -l pl.UTF-8
Bcachefs to nowy zaawansowany system plików dla Linuksa, kładący
nacisk na wiarygodności, solidności i kompletnym zestawie funkcji,
których można oczekiwać od nowoczesnego systemu plików.

Ten pakiet zawiera narzędzia przestrzeni użytkownika do bcachefs.

%prep
%setup -q
%patch0 -p1

%build
export RUSTFLAGS="%{rpmrustflags}"
export PKG_CONFIG_ALLOW_CROSS=1
export BINDGEN_EXTRA_CLANG_ARGS="%{rpmcflags} %{rpmcppflags}"
%ifnarch x32
export LIBCLANG_PATH="%{_libdir}"
%else
export LIBCLANG_PATH=/usr/lib64
%endif
%{__make} \
	V=1 \
	PREFIX="%{_prefix}" \
	ROOT_SBINDIR="%{_sbindir}" \
	LIBEXECDIR="%{_libexecdir}" \
	CC="%{__cc}" \
	EXTRA_CFLAGS="%{rpmcflags}" \
	EXTRA_LDFLAGS="%{rpmldflags}" \
	CARGO="%__cargo" \
	CARGO_BUILD_ARGS="-v --release --target %rust_target" \
	CARGO_TARGET="%rust_target"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man8}

# keep build env settings to avoid rebuilds ("dirty")
export RUSTFLAGS="%{rpmrustflags}"
export PKG_CONFIG_ALLOW_CROSS=1
export BINDGEN_EXTRA_CLANG_ARGS="%{rpmcflags} %{rpmcppflags}"
%ifnarch x32
export LIBCLANG_PATH="%{_libdir}"
%else
export LIBCLANG_PATH=/usr/lib64
%endif

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	V=1 \
	PREFIX="%{_prefix}" \
	ROOT_SBINDIR="%{_sbindir}" \
	LIBEXECDIR="%{_libexecdir}" \
	CARGO="%__cargo" \
	CARGO_BUILD_ARGS="-v --release --target %rust_target" \
	CARGO_TARGET="%rust_target"

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_sbindir}/bcachefs
%attr(755,root,root) %{_sbindir}/fsck.bcachefs
%attr(755,root,root) %{_sbindir}/fsck.fuse.bcachefs
%attr(755,root,root) %{_sbindir}/mkfs.bcachefs
%attr(755,root,root) %{_sbindir}/mkfs.fuse.bcachefs
%attr(755,root,root) %{_sbindir}/mount.bcachefs
%attr(755,root,root) %{_sbindir}/mount.fuse.bcachefs
%attr(755,root,root) %{_libexecdir}/bcachefsck_all
%attr(755,root,root) %{_libexecdir}/bcachefsck_fail
%{systemdunitdir}/bcachefsck@.service
%{systemdunitdir}/bcachefsck_all.service
%{systemdunitdir}/bcachefsck_all.timer
%{systemdunitdir}/bcachefsck_all_fail.service
%{systemdunitdir}/bcachefsck_fail@.service
%{systemdunitdir}/system-bcachefsck.slice
/lib/udev/rules.d/64-bcachefs.rules
%{_mandir}/man8/bcachefs.8*

# initramfs subpackage?
#%{_datadir}/initramfs-tools/hooks/bcachefs
#%{_datadir}/initramfs-tools/scripts/local-premount/bcachefs
%changelog
* Sat Oct 26 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/bcachefs-tools.git;a=log;h=master

* Fri Oct 25 2024 Jakub Bogusz <qboosh@pld-linux.org> b3e8d2e
- updated to 1.13.0

* Thu Aug 15 2024 Jakub Bogusz <qboosh@pld-linux.org> 4b660ee
- updated to 1.9.4

* Fri May 24 2024 Jan Palus <atler@pld-linux.org> d80e82f
- BR: clang for core headers used by bindgen

* Fri May 24 2024 Jakub Bogusz <qboosh@pld-linux.org> dc2835c
- release 1

* Fri May 24 2024 Jakub Bogusz <qboosh@pld-linux.org> 6dfb0bd
- PKG_CONFIG_ALLOW_CROSS also on install (for x32)

* Fri May 24 2024 Jakub Bogusz <qboosh@pld-linux.org> 95bfbd6
- avoid rebuilding on install

* Fri May 24 2024 Jakub Bogusz <qboosh@pld-linux.org> 053a3f8
- updated to 1.7.0

* Thu May 23 2024 Jakub Bogusz <qboosh@pld-linux.org> a80e6e2
- pl, package also fuse utils

* Mon Jan 22 2024 Jan Palus <atler@pld-linux.org> 70c8abd
- bindgen built for host arch hence use x86_64 clang-devel on x32

* Mon Jan 22 2024 Jan Palus <atler@pld-linux.org> 666c463
- explicitly set LIBCLANG_PATH

* Mon Jan 22 2024 Jan Palus <atler@pld-linux.org> 0dccc05
- filterout -fvar-tracking-assignments not supported by clang

* Mon Jan 22 2024 Jan Palus <atler@pld-linux.org> 714313b
- set additional bindgen flags through env var

* Sun Jan 21 2024 Jan Palus <atler@pld-linux.org> 294ac93
- up to 1.4.1

* Fri Jan 12 2024 Jan Palus <atler@pld-linux.org> 4f6020e
- fractional release due to build issues

* Fri Jan 12 2024 Jan Palus <atler@pld-linux.org> b6f610d
- BR: clang-devel llvm-devel for internal bindgen

* Fri Jan 12 2024 Jan Palus <atler@pld-linux.org> dc723b3
- set PKG_CONFIG_ALLOW_CROSS=1

* Fri Jan 12 2024 Jan Palus <atler@pld-linux.org> ba98985
- new

